// --------------------------------------------------------
// Copyright (c)
//
// contributions by Ansgar
//                  ansgar.radermacher@cea.fr
// maintained by    CEA LIST
//                  info-list@cea.fr

// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#define sendReceive_SendServer_BODY

/************************************************************
 SendServer class body
 ************************************************************/

// include associated header file
#include "sendReceive/SendServer.h"

// Derived includes directives
#include "rclcpp/rclcpp.hpp"
#include "sendReceive/SendServer_main.h"

// Include from Include declaration (body)
#include "rclcpp_components/register_node_macro.hpp"

// Register the component with class_loader.
// This acts as a sort of entry point, allowing the component to be discoverable when its library
// is being loaded into a running process.
RCLCPP_COMPONENTS_REGISTER_NODE (sendReceive::SendServer)

// End of Include declaration (body)

namespace sendReceive {

// static attributes (if any)

/**
 * 
 * @param commobj 
 */
void SendServer::fReceive(
    const simple_msgs::msg::Map::SharedPtr /*in*/commobj) {
  // the parameter is called "commobj"
  RCLCPP_INFO(get_logger(), "got map data");
  RCLCPP_INFO(get_logger(), "width: %d, height: %d', resolution: %0.2f",
      commobj->ogm.width, commobj->ogm.height, commobj->ogm.resolution);
}

/**
 * 
 * @param options 
 */
SendServer::SendServer(rclcpp::NodeOptions /*in*/options) :
    rclcpp_lifecycle::LifecycleNode("SendServer", options) {
  cbg_Response_ = create_callback_group(
      rclcpp::CallbackGroupType::MutuallyExclusive);

  rclcpp::SubscriptionOptions map_options;
  map_options.callback_group = cbg_Response_;
  map_recv_ = create_subscription < simple_msgs::msg::Map
      > ("map", rclcpp::QoS(rclcpp::KeepLast(100)).best_effort(), std::bind(
          &sendReceive::SendServer::fReceive, (SendServer*) this,
          std::placeholders::_1), map_options);

}

} // of namespace sendReceive

/************************************************************
 End of SendServer class body
 ************************************************************/
